<?php
/**
 * クラスの説明
 *
 * @package  kouenGoogleAnalytics
 * @author   kouen <kouen@tkouen.mydns.jp>
 * @since    PHP 5.3.8
 * @version  $Id: v 1.00 2011/12/05 16:45:20 danielc Exp $
 */
class kouen_GoogleAnalytics
{
	/**
	 * PC用のスクリプト読み込んで出力
	 */
	function readGoogleAnalyticsScript($a)
	{
		// フィールドと設定項目名のための変数
		$opt_name_pc = 'google_analytics_pc';

		// データベースから既存の設定値を読み込む
		$opt_val_pc = get_option( $opt_name_pc );
		print "".
			"<script type=\"text/javascript\">\n".
			"var _gaq = _gaq || [];\n".
			"_gaq.push(['_setAccount', '{$opt_val_pc}']);\n".
			"_gaq.push(['_trackPageview']);\n".
			"(function() {\n".
			"var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;\n".
			"ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';\n".
			"var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);\n".
			"})();\n".
			"</script>\n".
			"\n";
	}

	/**
	 * Ktai style用
	 */
	function readGoogleAnalyticsScriptKtaiStyle(){
		echo '<img src="' . $this->googleAnalyticsGetImageUrl() . '" />';
	}
	
	/**
	 * 携帯用のイメージソース生成メソッド（Googleさん提供ソース）
	 */
	function googleAnalyticsGetImageUrl() {
		$GA_PIXEL = "/ga.php";
		// データベースから既存の設定値を読み込む
		$GA_ACCOUNT = get_option( "google_analytics_mb" );
		$url = "";
		$url .= $GA_PIXEL . "?";
		$url .= "utmac=" . $GA_ACCOUNT;
		$url .= "&utmn=" . rand(0, 0x7fffffff);
		$referer = $_SERVER["HTTP_REFERER"];
		$query = $_SERVER["QUERY_STRING"];
		$path = $_SERVER["REQUEST_URI"];
		if (empty($referer)) {
		$referer = "-";
		}
		$url .= "&utmr=" . urlencode($referer);
		if (!empty($path)) {
		$url .= "&utmp=" . urlencode($path);
		}
		$url .= "&guid=ON";
		return str_replace("&", "&amp;", $url);
	}

	/**
	 * googleのウェブ プロパティ IDを登録
	 */
	function setGoogleAnalyticsScript()
	{
		add_menu_page('kouenGoogleAnalytics設定', 'kouenGAn設定', 8, __FILE__, array($this, 'inputForm'));
	}
	function inputForm(){
		$mobile_flg = false;
		$arr_active_plugins = get_option( "active_plugins" );
		if (array_search("ktai-style/ktai_style.php", $arr_active_plugins)) {
			$mobile_flg = true;
		}


		// フィールドと設定項目名のための変数
		$pc = "ウェブプロパティID(PC用)";
		$mb = "GA_ACCOUNT(携帯用)";
		$opt_name_pc = 'google_analytics_pc';
		$opt_name_mb = 'google_analytics_mb';
		$hidden_field_name = 'submit_hidden';
		$data_field_name_pc = $opt_name_pc;
		$data_field_name_mb = $opt_name_mb;
		
		$ga_file_flg = false;
		if (file_exists($_SERVER{'DOCUMENT_ROOT'}."/ga.php")) {
			$ga_file_flg = true;
		}

		// データベースから既存の設定値を読み込む
		$opt_val_pc = get_option( $opt_name_pc );
		$opt_val_mb = get_option( $opt_name_mb );
		// ユーザが何かの情報を投稿したかどうかをチェックする
		// 投稿していれば、このhiddenフィールドの値は'Y'にセットされる
		$update_str = "";
		$error_str = "";
		if( isset($_POST[ $hidden_field_name ]) && $_POST[ $hidden_field_name ] == 'Y' ) {
			$up = "";
			$er = "";
			// 投稿された値を読む
			if (isset($_POST[ $data_field_name_pc ]) && $opt_val_pc != $_POST[ $data_field_name_pc ]) {
				$opt_val_pc = $_POST[ $data_field_name_pc ];
				if ($opt_val_pc == "" || preg_match("/^UA\-\d+\-\d+$/", $opt_val_pc)) {
					// データベースに値を設定する
					update_option( $opt_name_pc, $opt_val_pc );
					$up.= $pc;
				} else {
					$er.= $pc;
				}
			}
			if ($ga_file_flg == true) {
				if (isset($_POST[ $data_field_name_mb ]) && $opt_val_mb != $_POST[ $data_field_name_mb ]) {
					$opt_val_mb = $_POST[ $data_field_name_mb ];
					if ($opt_val_mb == "" || preg_match("/^MO\-\d+\-\d+$/", $opt_val_mb)) {
						// データベースに値を設定する
						update_option( $opt_name_mb, $opt_val_mb );
						if($up != ""){$up.="・";}
						$up.= $mb;
						if($error_str != ""){$error_str.="・";}
						$er.= $mb;
					}
				}
			}

			if ($up != "") {
				$update_str = '<div class="updated"><p><strong>'.$up.'設定が完了しました。</strong></p></div>';
			}
			if ($er != "") {
				$error_str = '<div class="error"><p><strong>'.$er.'が不正です。</strong></p></div>';
			}
		}

		// 設定変更画面を表示する

		// 設定用フォーム
		echo <<<EOF
			<div class="wrap">
			{$update_str}
			{$error_str}
			<h2>Google Analytics 設定</h2>
			<form name="form1" method="post" action="{$_SERVER['REQUEST_URI']}">
			<input type="hidden" name="{$hidden_field_name}" value="Y" />

			<table style="border:1px solid #666;">
			<tr>
				<td style="background-color:#efefe0;padding:10px;width:150px;">{$pc}</td>
				<td>
				<input type="text" name="{$data_field_name_pc}" value="{$opt_val_pc}" size="20" />
				<div style="font-size:9px;color:#e03333;">※例：UA-xxxxxxxx-x</div>
				</td>
			</tr>
EOF;
		if ($ga_file_flg == true && $mobile_flg == true) {
	echo <<<EOF
			<tr>
				<td style="background-color:#efefe0;padding:10px;width:150px;">{$mb}</td>
				<td>
				<input type="text" name="{$data_field_name_mb}" value="{$opt_val_mb}" size="20" />
				<div style="font-size:9px;color:#e03333;">※例：MO-xxxxxxxx-x</div>
				</td>
			</tr>
EOF;
		}
	echo <<<EOF
			</table>
			<p class="submit">
			<input type="submit" name="Submit" value="設定" />
			</p>

			</form>

			<a href="http://www.google.com/analytics/" target="_blank">google Analytics</a>
			</div>
EOF;
	}
}

?>